﻿* Encoding: UTF-8.
*Series Response tools
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_RANKREV*/*******************************************************************.
define !KO_rankrev(vars= !charend('/') /capnum= !charend('/') /filler= !charend('/'))
!if (!filler=!null) !then !let !fill= '$sysmis' !else !let !fill= !filler !ifend
!let !nvars= !null !let !vlist= !null
!do !w !in (!vars)
 !let !nvars= !concat(!nvars,' ')
 !let !vlist= !concat(!vlist,',',!w)
!doend
!let !nvars= !length(!nvars) !let !vlist= !tail(!vlist)
!let !mxcode= !head(!tail(!capnum))
!if (!mxcode=!null) !then !let !mxcode= !nvars !ifend
!if (!capnum=!null) !then !let !newvrs= !vars !else !let !cap= !unquote(!head(!capnum)) !let !newvrs= !concat(!cap,1,' to ',!cap,!mxcode) !ifend
!if (!mxcode=1) !then !let !newvrs= !head(!newvrs) !ifend
vector #newv (!mxcode).
loop #i= 1 to !mxcode.
-comp #newv(#i)= !fill.
-do rep v= !vars /vn= 1 to !nvars.
- if v=#i #newv(#i)= vn.
-end rep.
end loop.
do rep newvar= !newvrs /i= 1 to !mxcode.
-comp newvar= #newv(i).
end rep.
!if (!filler<>!null) !then
-do if nvalid(!vlist)=0.
- recode !newvrs (else=sysmis).
-end if.
-miss val !newvrs (!filler).
!ifend
exec.
!if (!capnum<>!null) !then
-format !newvrs (f8).
!ifend
!enddefine.

*/*!KO_VALVARS*/*******************************************************************.
define !KO_valvars(vars= !charend('/') /values= !charend('/') /except= !charend('/') /newvars= !charend('/') /newvals= !charend('/') /filler= !charend('/') /miss= !charend('/') /redupl= !charend('/'))
!let !ok= 1
!if (!upcase(!head(!tail(!values)))='TO') !then !let !vals= !null
 !do !i= !head(!values) !to !tail(!tail(!values))
  !if (!index(!concat(' ',!except,' '),!concat(' ',!i,' '))=0) !then
   !let !vals= !concat(!vals,' ',!i)
  !ifend
 !doend
!else !let !vals= !values
!ifend
!let !cods= !null !let !vlist= !null !let !vrs= !vars !let !cds= !newvals
!do !i= 1 !to 999
 !let !vlist= !concat(!vlist,',',!head(!vrs))
 !if (!newvals='ORDINAL') !then !let !cods= !concat(!cods,' ',!i)
 !else
  !if (!newvals='ALLONE') !then !let !cods= !concat(!cods,' ',1)
  !else
   !if (!newvals='EXTRACT') !then !let !var= !head(!vrs) !let !code= !null
    !do !i2= !length(!var) !to 2 !by -1
     !if (!index('0123456789',!substr(!var,!i2,1))>0) !then !let !code= !substr(!var,!i2) !else !break !ifend
    !doend
    !if (!code<>!null) !then !let !cods= !concat(!cods,' ',!code)
    !else !let !ok= 0 !let !err= '>ОШИБКА. При NEWVALS=EXTRACT имена в VARS должны оканчиваться числом.' !break
    !ifend
   !else
    !if (!cds=!null) !then !break !ifend
    !let !cods= !concat(!cods,' ',!head(!cds)) !let !cds= !tail(!cds)
   !ifend
  !ifend
 !ifend
 !let !vrs= !tail(!vrs)
 !if (!vrs=!null) !then !break !ifend
!doend
!if (!newvals<>'ORDINAL' !and !newvals<>'EXTRACT' !and !newvals<>'ALLONE') !then
 !if (!vrs<>!cds) !then !let !ok= 0 !let !err= '>ОШИБКА. Списки VARS и NEWVALS разной длины.' !ifend
!ifend
!if (!tail(!newvars)<>!null) !then !let !newvrs= !newvars
 !do !val !in (!vals)
  !if (!newvrs=!null) !then !let !ok= 0 !let !err= '>ОШИБКА. Списки VALUES и NEWVARS разной длины.' !break !ifend
  !let !newvrs= !tail(!newvrs)
 !doend
 !if (!newvrs<>!null) !then !let !ok= 0 !let !err= '>ОШИБКА. Списки VALUES и NEWVARS разной длины.' !ifend
 !let !newvrs= !newvars
!else !let !cap= !unquote(!newvars) !let !newvrs= !null
 !do !val !in (!vals)
  !let !newvrs= !concat(!newvrs,' ',!cap,!val)
 !doend
!ifend
!if (!not !ok) !then
-do if $casenum=1.
- print /!quote(!err).
-end if.
!else
 !if (!redupl='RANGE') !then !let !min= 'comp #min= $sysmis' !let !max= 'comp #max= $sysmis' !ifend
 !if (!redupl='RANDOM' !or !redupl='FIRST' !or !redupl='LAST' !or !redupl=!null) !then !let !lfr= 1
  !if (!redupl='RANDOM' !or !redupl='FIRST') !then !let !rn1= 'comp #rn1= 0' !let !rn2= 'comp #rn2= uniform(1)' !let !doifrn= 'do if #rn2>=#rn1' !let !endifrn= 'end if'
   !if (!redupl='RANDOM') !then !let !rn1rn2= 'comp #rn1= #rn2' !else !let !rn1rn2= 'comp #rn1= 1.1' !ifend
  !ifend
 !else !let !lfr= 0
  !if (!redupl='MIN' !or !redupl='MAX') !then !let !func= !redupl !ifend
  !if (!redupl='MINGAP' !or !redupl='MAXGAP') !then !let !precode= 'comp #precode= $sysmis' !let !func= !substr(!redupl,1,3) !let !prec2= 'comp #precode= code' !let !mprec= '-#precode'
   !if (!redupl='MAXGAP') !then !let !prec1= 'if sysmis(#precode) #precode= code' !ifend
  !ifend
  !if (!redupl='SUM' !or !redupl='MEAN') !then !let !func= 'sum'
   !if (!redupl='MEAN') !then !let !ifmiss= 'if missing(code) #n= #n-1' !ifend
  !ifend
 !ifend
 !if ((!redupl='MINGAP' !or !redupl='MAXGAP') !and !newvals<>'ORDINAL' !and !newvals<>'ALLONE') !then
- do rep code= !cods /#tc= #tc1 to !concat('#tc',!i).
-  comp #tc= code.
- end rep.
- do rep var= !vars /#tv= #tv1 to !concat('#tv',!i).
-  comp #tv= var.
- end rep.
- vector #tc= #tc1 to !concat('#tc',!i) /#tv= #tv1 to !concat('#tv',!i) /#c #v (!i).
- loop #i= 1 to !i.
-  comp #c(#i)= min(#tc1 to !concat('#tc',!i)).
-  loop #i2= 1 to !i.
-   do if #tc(#i2)=#c(#i).
-    comp #tc(#i2)= $sysmis.
-    comp #v(#i)= #tv(#i2).
-    break.
-   end if.
-  end loop.
-  if missing(#c(#i)) #v(#i)= $sysmis.
- end loop.
  !let !cods= !concat('#c1 to #c',!i) !let !vrs= !concat('#v1 to #v',!i)
 !else !let !vrs= !vars
 !ifend
 !do !newvar !in (!newvrs)
  !let !val= !head(!vals) !let !vals= !tail(!vals)
- !rn1.
- !min.
- !max.
- !precode.
- count #n= !vrs (!val).
- do if #n>0.
-  do rep var= !vrs /code= !cods.
-   do if var=!val.
     !if (!redupl='RANGE') !then
-       comp #min= min(#min,code).
-       comp #max= max(#max,code).
     !else
      !if (!lfr) !then
-      !rn2.
-      !doifrn.
-       comp !newvar= code.
-       !rn1rn2.
-      !endifrn.
      !else
-       !prec1.
-       comp !newvar= !func(!newvar,code!mprec).
-       !ifmiss.
-       !prec2.
      !ifend
     !ifend
-   end if.
-  end rep.
   !if (!redupl='RANGE') !then
-   comp !newvar= #max-#min.
   !ifend
   !if (!redupl='MEAN') !then
-   if #n>0 !newvar= !newvar/#n.
   !ifend
   !if (!redupl='MINGAP') !then
-   if sysmis(!newvar) and not sysmis(#precode) !newvar= 0.
   !ifend
- end if.
 !doend
 !if (!filler<>!null) !then
- recode !newvrs (sysmis=!filler).
- miss val !newvrs (!filler).
 !ifend
 !if (!miss<>!null) !then
  !if (!miss='SET') !then
-  do if nvalid(!tail(!vlist))=0.
  !else
-  do if missing(!miss).
  !ifend
-   recode !newvrs (else=sysmis).
-  end if.
 !ifend
 !if ((!newvals='EXTRACT' !or !newvals='ORDINAL' !or !newvals='ALLONE') !and !redupl<>'MEAN') !then
- format !newvrs (f8).
 !ifend
!ifend
exec.
!enddefine.

*/*!KO_SRSREF*/*******************************************************************.
define !KO_srsref(pack= !charend('/') /series= !charend('/') /refer= !charend('/') /rated= !charend('/') /except= !charend('/') /cap= !charend('/') /rtimes= !charend('/') !default(1) /noans= !charend('/') /nosel= !charend('/'))
!if (!upcase(!head(!tail(!rated)))='TO') !then !let !rtd= !null
 !do !i= !head(!rated) !to !tail(!tail(!rated))
  !if (!index(!concat(' ',!except,' '),!concat(' ',!i,' '))=0) !then
   !let !rtd= !concat(!rtd,' ',!i)
  !ifend
 !doend
!else !let !rtd= !rated
!ifend
!if (!pack='MRATED') !then !let !rt= 1 !else !let !rt= !rtimes !ifend
!let !codes= !null !let !count= !null !let !newser= !null
!do !w !in (!rtd)
 !do !i= 1 !to !rt
  !let !codes= !concat(!codes,' ',!w)
  !let !count= !concat(!count,' ')
  !if (!rt=1) !then !let !n= !null !else !let !n= !concat('#',!i) !ifend
  !let !newvar= !concat(!unquote(!cap),!w,!n) !let !newser= !concat(!newser,' ',!newvar)
 !doend
!doend
!let !count= !length(!count)
numer !newser.
!if (!nosel<>!null) !then
-recode !newser (else=!nosel).
-miss val !newser (!nosel).
!ifend
vector series= !series.
!if (!upcase(!head(!tail(!refer)))='TO') !then !let !ref= !refer
!else !let !ref= !null
 !do !w !in (!refer)
  !let !ref= !concat(!ref,',',!w)
 !doend
 !let !ref= !tail(!ref)
!ifend
comp #ord= 1.
!if (!pack='MRATED') !then
-do rep w= !codes /newser= !newser.
- do if any(w,!ref).
-  comp newser= series(#ord).
   !if (!noans<>!null) !then
-   if missing(series(#ord)) newser= !noans.
   !ifend
-  comp #ord= #ord+1.
- end if.
-end rep.
!else
-do rep w= !codes /v= #1 to !concat('#',!count).
- comp v= w.
-end rep.
-vector #codes= #1 to !concat('#',!count) /newser= !head(!newser) to !newvar.
 !if (!pack='IREFER') !then !let !calc= 's'
- do rep w= !refer /s= !series.
 !else !let !calc= 'series(#ord)'
- do rep w= !refer.
 !ifend
-  loop #i= 1 to !count.
-   do if #codes(#i)=w.
-    comp newser(#i)= !calc.
     !if (!noans<>!null) !then
-     if missing(!calc) newser(#i)= !noans.
     !ifend
     !if (!pack='MREFER') !then
-     comp #ord= #ord+1.
     !ifend
-    comp #codes(#i)= $sysmis.
-    break.
-   end if.
-  end loop.
- end rep.
!ifend
do if nvalid(!ref)=0.
-recode !newser (else=sysmis).
end if.
exec.
!enddefine.
